/************************************************************
Module name: PMRest.C
Notices: Copyright (c) 1995 Jeffrey Richter
************************************************************/


#include "..\AdvWin32.H"    /* See Appendix B for details. */
#include <windows.h>

#pragma warning(disable: 4001)      /* Single-line comment */

#include <stdio.h>

#include "Resource.H"
#include "PMRstSub.H"


/////////////////////////////////////////////////////////////


#define LIBNAME   "PMRstSub"

#if defined(_X86_)
   #if defined(_DEBUG)
      #pragma comment(lib, "Dbg_x86\\" LIBNAME)
   #else
      #pragma comment(lib, "Rel_x86\\" LIBNAME)
   #endif
#elif defined(_MIPS_)
   #if defined(_DEBUG)
      #pragma comment(lib, "Dbg_MIPS\\" LIBNAME)
   #else
      #pragma comment(lib, "Rel_MIPS\\" LIBNAME)
   #endif
#elif defined(_ALPHA_)
   #if defined(_DEBUG)
      #pragma comment(lib, "Dbg_Alph\\" LIBNAME)
   #else
      #pragma comment(lib, "Rel_Alph\\" LIBNAME)
   #endif
#else
   #error Modification required for this CPU platform.
#endif


/////////////////////////////////////////////////////////////


int WINAPI WinMain (HINSTANCE hinstExe,
   HINSTANCE hinstPrev, LPSTR lpszCmdLine, int nCmdShow) {

   MSG msg;

   // Find the Program Manager and modify its menu.
   if (!SubclassProgManFrame(GetCurrentThreadId()))
      return(1);

   // Begin message loop so that our application 
   // doesn't terminate. If we did terminate, our subclass
   // function would be removed from memory. This means that
   // when the system tried to call the subclass function,
   // the system would jump to garbage and cause an access
   // violation.
   while (GetMessage(&msg, NULL, 0, 0))
      ;

   // Uninstall the WH_GETMESSAGE hook.
   // This causes the DLL to be unmapped 
   // from the Program Manager.
   if (!UnhookWindowsHookEx(g_hHook)) {
      MessageBox(NULL, __TEXT("Error unhooking"),
         __TEXT("PM Restore"), MB_OK);
   }

   return(0);
}


//////////////////////// End Of File ////////////////////////
